/* engine.c generated by valac 0.42.6, the Vala compiler
 * generated from engine.vala, do not modify */

/*
 * Copyright (c) 2011 Lucas Baudin <xapantu@gmail.com>
 *
 * This is a free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; see the file COPYING.  If not,
 * write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 */


#include <glib.h>
#include <glib-object.h>
#include <gee.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>


#define EUCLIDE_COMPLETION_TYPE_PARSER (euclide_completion_parser_get_type ())
#define EUCLIDE_COMPLETION_PARSER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), EUCLIDE_COMPLETION_TYPE_PARSER, EuclideCompletionParser))
#define EUCLIDE_COMPLETION_PARSER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), EUCLIDE_COMPLETION_TYPE_PARSER, EuclideCompletionParserClass))
#define EUCLIDE_COMPLETION_IS_PARSER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), EUCLIDE_COMPLETION_TYPE_PARSER))
#define EUCLIDE_COMPLETION_IS_PARSER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), EUCLIDE_COMPLETION_TYPE_PARSER))
#define EUCLIDE_COMPLETION_PARSER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), EUCLIDE_COMPLETION_TYPE_PARSER, EuclideCompletionParserClass))

typedef struct _EuclideCompletionParser EuclideCompletionParser;
typedef struct _EuclideCompletionParserClass EuclideCompletionParserClass;
typedef struct _EuclideCompletionParserPrivate EuclideCompletionParserPrivate;
enum  {
	EUCLIDE_COMPLETION_PARSER_0_PROPERTY,
	EUCLIDE_COMPLETION_PARSER_NUM_PROPERTIES
};
static GParamSpec* euclide_completion_parser_properties[EUCLIDE_COMPLETION_PARSER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _EuclideCompletionParser {
	GObject parent_instance;
	EuclideCompletionParserPrivate * priv;
	GeeHashMap* text_view_words;
	gboolean parsing_cancelled;
};

struct _EuclideCompletionParserClass {
	GObjectClass parent_class;
};

struct _EuclideCompletionParserPrivate {
	GeeArrayList* words;
	GRecMutex __lock_words;
	gchar* last_word;
};


static gint EuclideCompletionParser_private_offset;
static gpointer euclide_completion_parser_parent_class = NULL;
static GType euclide_completion_parser_type_id = 0;

GType euclide_completion_parser_register_type (GTypeModule * module);
GType euclide_completion_parser_get_type (void) G_GNUC_CONST;
#define EUCLIDE_COMPLETION_PARSER_MINIMUM_WORD_LENGTH 1
#define EUCLIDE_COMPLETION_PARSER_MAX_TOKENS 1000000
#define EUCLIDE_COMPLETION_PARSER_delimiters " .,;:?{}[]()0123456789+-=&|-<>*\\/\n\t\'\""
gboolean euclide_completion_parser_is_delimiter (EuclideCompletionParser* self,
                                                 gunichar c);
EuclideCompletionParser* euclide_completion_parser_new (void);
EuclideCompletionParser* euclide_completion_parser_construct (GType object_type);
void euclide_completion_parser_add_last_word (EuclideCompletionParser* self);
static void euclide_completion_parser_add_word (EuclideCompletionParser* self,
                                         const gchar* word);
gboolean euclide_completion_parser_get_for_word (EuclideCompletionParser* self,
                                                 const gchar* to_find,
                                                 GeeTreeSet* * list);
void euclide_completion_parser_rebuild_word_list (EuclideCompletionParser* self,
                                                  GtkTextView* view);
void euclide_completion_parser_parse_text_view (EuclideCompletionParser* self,
                                                GtkTextView* view);
static gboolean euclide_completion_parser_parse_string (EuclideCompletionParser* self,
                                                 const gchar* text);
void euclide_completion_parser_cancel_parsing (EuclideCompletionParser* self);
static void euclide_completion_parser_finalize (GObject * obj);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


static inline gpointer
euclide_completion_parser_get_instance_private (EuclideCompletionParser* self)
{
	return G_STRUCT_MEMBER_P (self, EuclideCompletionParser_private_offset);
}


static gint
string_index_of_char (const gchar* self,
                      gunichar c,
                      gint start_index)
{
	gint result = 0;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 1101 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1102 "glib-2.0.vapi"
	_tmp0_ = g_utf8_strchr (((gchar*) self) + start_index, (gssize) -1, c);
#line 1102 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1104 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1104 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 132 "engine.c"
		gchar* _tmp2_;
#line 1105 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1105 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1105 "glib-2.0.vapi"
		return result;
#line 140 "engine.c"
	} else {
#line 1107 "glib-2.0.vapi"
		result = -1;
#line 1107 "glib-2.0.vapi"
		return result;
#line 146 "engine.c"
	}
}


gboolean
euclide_completion_parser_is_delimiter (EuclideCompletionParser* self,
                                        gunichar c)
{
	gboolean result = FALSE;
#line 26 "../plugins/word-completion/engine.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 27 "../plugins/word-completion/engine.vala"
	result = string_index_of_char (EUCLIDE_COMPLETION_PARSER_delimiters, c, 0) >= 0;
#line 27 "../plugins/word-completion/engine.vala"
	return result;
#line 162 "engine.c"
}


EuclideCompletionParser*
euclide_completion_parser_construct (GType object_type)
{
	EuclideCompletionParser * self = NULL;
	GeeHashMap* _tmp0_;
#line 36 "../plugins/word-completion/engine.vala"
	self = (EuclideCompletionParser*) g_object_new (object_type, NULL);
#line 37 "../plugins/word-completion/engine.vala"
	_tmp0_ = gee_hash_map_new (gtk_text_view_get_type (), (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, GEE_TYPE_ARRAY_LIST, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 37 "../plugins/word-completion/engine.vala"
	_g_object_unref0 (self->text_view_words);
#line 37 "../plugins/word-completion/engine.vala"
	self->text_view_words = _tmp0_;
#line 36 "../plugins/word-completion/engine.vala"
	return self;
#line 181 "engine.c"
}


EuclideCompletionParser*
euclide_completion_parser_new (void)
{
#line 36 "../plugins/word-completion/engine.vala"
	return euclide_completion_parser_construct (EUCLIDE_COMPLETION_TYPE_PARSER);
#line 190 "engine.c"
}


void
euclide_completion_parser_add_last_word (EuclideCompletionParser* self)
{
	const gchar* _tmp0_;
#line 40 "../plugins/word-completion/engine.vala"
	g_return_if_fail (self != NULL);
#line 41 "../plugins/word-completion/engine.vala"
	_tmp0_ = self->priv->last_word;
#line 41 "../plugins/word-completion/engine.vala"
	euclide_completion_parser_add_word (self, _tmp0_);
#line 204 "engine.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 50 "../plugins/word-completion/engine.vala"
	return self ? g_object_ref (self) : NULL;
#line 213 "engine.c"
}


static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	gchar* result = NULL;
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gchar* _tmp8_;
#line 1425 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1426 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1426 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1426 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1427 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 239 "engine.c"
		glong _tmp2_;
#line 1428 "glib-2.0.vapi"
		_tmp2_ = string_length;
#line 1428 "glib-2.0.vapi"
		start = _tmp2_ + start;
#line 245 "engine.c"
	}
#line 1430 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 249 "engine.c"
		glong _tmp3_;
#line 1431 "glib-2.0.vapi"
		_tmp3_ = string_length;
#line 1431 "glib-2.0.vapi"
		end = _tmp3_ + end;
#line 255 "engine.c"
	}
#line 1433 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 259 "engine.c"
		glong _tmp5_;
#line 1433 "glib-2.0.vapi"
		_tmp5_ = string_length;
#line 1433 "glib-2.0.vapi"
		_tmp4_ = start <= _tmp5_;
#line 265 "engine.c"
	} else {
#line 1433 "glib-2.0.vapi"
		_tmp4_ = FALSE;
#line 269 "engine.c"
	}
#line 1433 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp4_, NULL);
#line 1434 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 275 "engine.c"
		glong _tmp7_;
#line 1434 "glib-2.0.vapi"
		_tmp7_ = string_length;
#line 1434 "glib-2.0.vapi"
		_tmp6_ = end <= _tmp7_;
#line 281 "engine.c"
	} else {
#line 1434 "glib-2.0.vapi"
		_tmp6_ = FALSE;
#line 285 "engine.c"
	}
#line 1434 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp6_, NULL);
#line 1435 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1436 "glib-2.0.vapi"
	_tmp8_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1436 "glib-2.0.vapi"
	result = _tmp8_;
#line 1436 "glib-2.0.vapi"
	return result;
#line 297 "engine.c"
}


gboolean
euclide_completion_parser_get_for_word (EuclideCompletionParser* self,
                                        const gchar* to_find,
                                        GeeTreeSet* * list)
{
	GeeTreeSet* _vala_list = NULL;
	gboolean result = FALSE;
	guint length = 0U;
	gint _tmp0_;
	gint _tmp1_;
	GeeTreeSet* _tmp2_;
	gchar* _tmp3_;
	GeeArrayList* _tmp4_;
	GeeTreeSet* _tmp30_;
	gboolean _tmp31_;
	gboolean _tmp32_;
	GError* _inner_error0_ = NULL;
#line 44 "../plugins/word-completion/engine.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 44 "../plugins/word-completion/engine.vala"
	g_return_val_if_fail (to_find != NULL, FALSE);
#line 45 "../plugins/word-completion/engine.vala"
	_tmp0_ = strlen (to_find);
#line 45 "../plugins/word-completion/engine.vala"
	_tmp1_ = _tmp0_;
#line 45 "../plugins/word-completion/engine.vala"
	length = (guint) _tmp1_;
#line 46 "../plugins/word-completion/engine.vala"
	_tmp2_ = gee_tree_set_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 46 "../plugins/word-completion/engine.vala"
	_g_object_unref0 (_vala_list);
#line 46 "../plugins/word-completion/engine.vala"
	_vala_list = _tmp2_;
#line 47 "../plugins/word-completion/engine.vala"
	_tmp3_ = g_strdup (to_find);
#line 47 "../plugins/word-completion/engine.vala"
	_g_free0 (self->priv->last_word);
#line 47 "../plugins/word-completion/engine.vala"
	self->priv->last_word = _tmp3_;
#line 48 "../plugins/word-completion/engine.vala"
	_tmp4_ = self->priv->words;
#line 48 "../plugins/word-completion/engine.vala"
	if (_tmp4_ != NULL) {
#line 344 "engine.c"
		{
			GeeArrayList* _tmp5_;
#line 49 "../plugins/word-completion/engine.vala"
			_tmp5_ = self->priv->words;
#line 49 "../plugins/word-completion/engine.vala"
			g_rec_mutex_lock (&self->priv->__lock_words);
#line 351 "engine.c"
			{
				{
					GeeArrayList* _word_list = NULL;
					GeeArrayList* _tmp6_;
					GeeArrayList* _tmp7_;
					gint _word_size = 0;
					GeeArrayList* _tmp8_;
					gint _tmp9_;
					gint _tmp10_;
					gint _word_index = 0;
#line 50 "../plugins/word-completion/engine.vala"
					_tmp6_ = self->priv->words;
#line 50 "../plugins/word-completion/engine.vala"
					_tmp7_ = _g_object_ref0 (_tmp6_);
#line 50 "../plugins/word-completion/engine.vala"
					_word_list = _tmp7_;
#line 50 "../plugins/word-completion/engine.vala"
					_tmp8_ = _word_list;
#line 50 "../plugins/word-completion/engine.vala"
					_tmp9_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp8_);
#line 50 "../plugins/word-completion/engine.vala"
					_tmp10_ = _tmp9_;
#line 50 "../plugins/word-completion/engine.vala"
					_word_size = _tmp10_;
#line 50 "../plugins/word-completion/engine.vala"
					_word_index = -1;
#line 50 "../plugins/word-completion/engine.vala"
					while (TRUE) {
#line 380 "engine.c"
						gint _tmp11_;
						gint _tmp12_;
						gint _tmp13_;
						gchar* word = NULL;
						GeeArrayList* _tmp14_;
						gint _tmp15_;
						gpointer _tmp16_;
						gboolean _tmp17_ = FALSE;
						const gchar* _tmp18_;
						gint _tmp19_;
						gint _tmp20_;
						guint _tmp21_;
#line 50 "../plugins/word-completion/engine.vala"
						_tmp11_ = _word_index;
#line 50 "../plugins/word-completion/engine.vala"
						_word_index = _tmp11_ + 1;
#line 50 "../plugins/word-completion/engine.vala"
						_tmp12_ = _word_index;
#line 50 "../plugins/word-completion/engine.vala"
						_tmp13_ = _word_size;
#line 50 "../plugins/word-completion/engine.vala"
						if (!(_tmp12_ < _tmp13_)) {
#line 50 "../plugins/word-completion/engine.vala"
							break;
#line 405 "engine.c"
						}
#line 50 "../plugins/word-completion/engine.vala"
						_tmp14_ = _word_list;
#line 50 "../plugins/word-completion/engine.vala"
						_tmp15_ = _word_index;
#line 50 "../plugins/word-completion/engine.vala"
						_tmp16_ = gee_abstract_list_get ((GeeAbstractList*) _tmp14_, _tmp15_);
#line 50 "../plugins/word-completion/engine.vala"
						word = (gchar*) _tmp16_;
#line 51 "../plugins/word-completion/engine.vala"
						_tmp18_ = word;
#line 51 "../plugins/word-completion/engine.vala"
						_tmp19_ = strlen (_tmp18_);
#line 51 "../plugins/word-completion/engine.vala"
						_tmp20_ = _tmp19_;
#line 51 "../plugins/word-completion/engine.vala"
						_tmp21_ = length;
#line 51 "../plugins/word-completion/engine.vala"
						if (((guint) _tmp20_) > _tmp21_) {
#line 425 "engine.c"
							const gchar* _tmp22_;
							guint _tmp23_;
							gchar* _tmp24_;
							gchar* _tmp25_;
#line 51 "../plugins/word-completion/engine.vala"
							_tmp22_ = word;
#line 51 "../plugins/word-completion/engine.vala"
							_tmp23_ = length;
#line 51 "../plugins/word-completion/engine.vala"
							_tmp24_ = string_slice (_tmp22_, (glong) 0, (glong) _tmp23_);
#line 51 "../plugins/word-completion/engine.vala"
							_tmp25_ = _tmp24_;
#line 51 "../plugins/word-completion/engine.vala"
							_tmp17_ = g_strcmp0 (_tmp25_, to_find) == 0;
#line 51 "../plugins/word-completion/engine.vala"
							_g_free0 (_tmp25_);
#line 442 "engine.c"
						} else {
#line 51 "../plugins/word-completion/engine.vala"
							_tmp17_ = FALSE;
#line 446 "engine.c"
						}
#line 51 "../plugins/word-completion/engine.vala"
						if (_tmp17_) {
#line 450 "engine.c"
							GeeTreeSet* _tmp26_;
							const gchar* _tmp27_;
#line 52 "../plugins/word-completion/engine.vala"
							_tmp26_ = _vala_list;
#line 52 "../plugins/word-completion/engine.vala"
							_tmp27_ = word;
#line 52 "../plugins/word-completion/engine.vala"
							gee_abstract_collection_add ((GeeAbstractCollection*) _tmp26_, _tmp27_);
#line 459 "engine.c"
						}
#line 50 "../plugins/word-completion/engine.vala"
						_g_free0 (word);
#line 463 "engine.c"
					}
#line 50 "../plugins/word-completion/engine.vala"
					_g_object_unref0 (_word_list);
#line 467 "engine.c"
				}
			}
			__finally1:
			{
				GeeArrayList* _tmp28_;
#line 49 "../plugins/word-completion/engine.vala"
				_tmp28_ = self->priv->words;
#line 49 "../plugins/word-completion/engine.vala"
				g_rec_mutex_unlock (&self->priv->__lock_words);
#line 477 "engine.c"
			}
#line 49 "../plugins/word-completion/engine.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 481 "engine.c"
				gboolean _tmp29_ = FALSE;
#line 49 "../plugins/word-completion/engine.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 49 "../plugins/word-completion/engine.vala"
				g_clear_error (&_inner_error0_);
#line 49 "../plugins/word-completion/engine.vala"
				return _tmp29_;
#line 489 "engine.c"
			}
		}
	}
#line 58 "../plugins/word-completion/engine.vala"
	_tmp30_ = _vala_list;
#line 58 "../plugins/word-completion/engine.vala"
	_tmp31_ = gee_collection_get_is_empty ((GeeCollection*) _tmp30_);
#line 58 "../plugins/word-completion/engine.vala"
	_tmp32_ = _tmp31_;
#line 58 "../plugins/word-completion/engine.vala"
	result = !_tmp32_;
#line 58 "../plugins/word-completion/engine.vala"
	if (list) {
#line 58 "../plugins/word-completion/engine.vala"
		*list = _vala_list;
#line 505 "engine.c"
	} else {
#line 58 "../plugins/word-completion/engine.vala"
		_g_object_unref0 (_vala_list);
#line 509 "engine.c"
	}
#line 58 "../plugins/word-completion/engine.vala"
	return result;
#line 513 "engine.c"
}


void
euclide_completion_parser_rebuild_word_list (EuclideCompletionParser* self,
                                             GtkTextView* view)
{
	GError* _inner_error0_ = NULL;
#line 61 "../plugins/word-completion/engine.vala"
	g_return_if_fail (self != NULL);
#line 61 "../plugins/word-completion/engine.vala"
	g_return_if_fail (view != NULL);
#line 526 "engine.c"
	{
		GeeArrayList* _tmp0_;
#line 62 "../plugins/word-completion/engine.vala"
		_tmp0_ = self->priv->words;
#line 62 "../plugins/word-completion/engine.vala"
		g_rec_mutex_lock (&self->priv->__lock_words);
#line 533 "engine.c"
		{
			GeeArrayList* _tmp1_;
#line 63 "../plugins/word-completion/engine.vala"
			_tmp1_ = self->priv->words;
#line 63 "../plugins/word-completion/engine.vala"
			gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp1_);
#line 540 "engine.c"
		}
		__finally2:
		{
			GeeArrayList* _tmp2_;
#line 62 "../plugins/word-completion/engine.vala"
			_tmp2_ = self->priv->words;
#line 62 "../plugins/word-completion/engine.vala"
			g_rec_mutex_unlock (&self->priv->__lock_words);
#line 549 "engine.c"
		}
#line 62 "../plugins/word-completion/engine.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 62 "../plugins/word-completion/engine.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 62 "../plugins/word-completion/engine.vala"
			g_clear_error (&_inner_error0_);
#line 62 "../plugins/word-completion/engine.vala"
			return;
#line 559 "engine.c"
		}
	}
#line 65 "../plugins/word-completion/engine.vala"
	euclide_completion_parser_parse_text_view (self, view);
#line 564 "engine.c"
}


void
euclide_completion_parser_parse_text_view (EuclideCompletionParser* self,
                                           GtkTextView* view)
{
	GtkTextBuffer* _tmp6_;
	GtkTextBuffer* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gint _tmp11_;
	gint _tmp12_;
	gboolean _tmp13_;
	GError* _inner_error0_ = NULL;
#line 68 "../plugins/word-completion/engine.vala"
	g_return_if_fail (self != NULL);
#line 68 "../plugins/word-completion/engine.vala"
	g_return_if_fail (view != NULL);
#line 585 "engine.c"
	{
		GeeArrayList* _tmp0_;
#line 70 "../plugins/word-completion/engine.vala"
		_tmp0_ = self->priv->words;
#line 70 "../plugins/word-completion/engine.vala"
		g_rec_mutex_lock (&self->priv->__lock_words);
#line 592 "engine.c"
		{
			GeeHashMap* _tmp1_;
#line 71 "../plugins/word-completion/engine.vala"
			_tmp1_ = self->text_view_words;
#line 71 "../plugins/word-completion/engine.vala"
			if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp1_, view)) {
#line 599 "engine.c"
				GeeHashMap* _tmp2_;
				gpointer _tmp3_;
#line 72 "../plugins/word-completion/engine.vala"
				_tmp2_ = self->text_view_words;
#line 72 "../plugins/word-completion/engine.vala"
				_tmp3_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp2_, view);
#line 72 "../plugins/word-completion/engine.vala"
				_g_object_unref0 (self->priv->words);
#line 72 "../plugins/word-completion/engine.vala"
				self->priv->words = (GeeArrayList*) _tmp3_;
#line 610 "engine.c"
			} else {
				GeeArrayList* _tmp4_;
#line 75 "../plugins/word-completion/engine.vala"
				_tmp4_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 75 "../plugins/word-completion/engine.vala"
				_g_object_unref0 (self->priv->words);
#line 75 "../plugins/word-completion/engine.vala"
				self->priv->words = _tmp4_;
#line 619 "engine.c"
			}
		}
		__finally3:
		{
			GeeArrayList* _tmp5_;
#line 70 "../plugins/word-completion/engine.vala"
			_tmp5_ = self->priv->words;
#line 70 "../plugins/word-completion/engine.vala"
			g_rec_mutex_unlock (&self->priv->__lock_words);
#line 629 "engine.c"
		}
#line 70 "../plugins/word-completion/engine.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 70 "../plugins/word-completion/engine.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 70 "../plugins/word-completion/engine.vala"
			g_clear_error (&_inner_error0_);
#line 70 "../plugins/word-completion/engine.vala"
			return;
#line 639 "engine.c"
		}
	}
#line 79 "../plugins/word-completion/engine.vala"
	_tmp6_ = gtk_text_view_get_buffer (view);
#line 79 "../plugins/word-completion/engine.vala"
	_tmp7_ = _tmp6_;
#line 79 "../plugins/word-completion/engine.vala"
	g_object_get (_tmp7_, "text", &_tmp8_, NULL);
#line 79 "../plugins/word-completion/engine.vala"
	_tmp9_ = _tmp8_;
#line 79 "../plugins/word-completion/engine.vala"
	_tmp10_ = _tmp9_;
#line 79 "../plugins/word-completion/engine.vala"
	_tmp11_ = strlen (_tmp10_);
#line 79 "../plugins/word-completion/engine.vala"
	_tmp12_ = _tmp11_;
#line 79 "../plugins/word-completion/engine.vala"
	_tmp13_ = _tmp12_ > 0;
#line 79 "../plugins/word-completion/engine.vala"
	_g_free0 (_tmp10_);
#line 79 "../plugins/word-completion/engine.vala"
	if (_tmp13_) {
#line 662 "engine.c"
		GtkTextBuffer* _tmp14_;
		GtkTextBuffer* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		GeeHashMap* _tmp19_;
		GeeArrayList* _tmp20_;
#line 80 "../plugins/word-completion/engine.vala"
		_tmp14_ = gtk_text_view_get_buffer (view);
#line 80 "../plugins/word-completion/engine.vala"
		_tmp15_ = _tmp14_;
#line 80 "../plugins/word-completion/engine.vala"
		g_object_get (_tmp15_, "text", &_tmp16_, NULL);
#line 80 "../plugins/word-completion/engine.vala"
		_tmp17_ = _tmp16_;
#line 80 "../plugins/word-completion/engine.vala"
		_tmp18_ = _tmp17_;
#line 80 "../plugins/word-completion/engine.vala"
		euclide_completion_parser_parse_string (self, _tmp18_);
#line 80 "../plugins/word-completion/engine.vala"
		_g_free0 (_tmp18_);
#line 81 "../plugins/word-completion/engine.vala"
		_tmp19_ = self->text_view_words;
#line 81 "../plugins/word-completion/engine.vala"
		_tmp20_ = self->priv->words;
#line 81 "../plugins/word-completion/engine.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp19_, view, _tmp20_);
#line 690 "engine.c"
	}
}


static void
euclide_completion_parser_add_word (EuclideCompletionParser* self,
                                    const gchar* word)
{
	gint _tmp0_;
	gint _tmp1_;
	GeeArrayList* _tmp2_;
	GError* _inner_error0_ = NULL;
#line 85 "../plugins/word-completion/engine.vala"
	g_return_if_fail (self != NULL);
#line 85 "../plugins/word-completion/engine.vala"
	g_return_if_fail (word != NULL);
#line 86 "../plugins/word-completion/engine.vala"
	_tmp0_ = strlen (word);
#line 86 "../plugins/word-completion/engine.vala"
	_tmp1_ = _tmp0_;
#line 86 "../plugins/word-completion/engine.vala"
	if (_tmp1_ < EUCLIDE_COMPLETION_PARSER_MINIMUM_WORD_LENGTH) {
#line 87 "../plugins/word-completion/engine.vala"
		return;
#line 715 "engine.c"
	}
#line 89 "../plugins/word-completion/engine.vala"
	_tmp2_ = self->priv->words;
#line 89 "../plugins/word-completion/engine.vala"
	if (!gee_abstract_collection_contains ((GeeAbstractCollection*) _tmp2_, word)) {
#line 721 "engine.c"
		{
			GeeArrayList* _tmp3_;
#line 90 "../plugins/word-completion/engine.vala"
			_tmp3_ = self->priv->words;
#line 90 "../plugins/word-completion/engine.vala"
			g_rec_mutex_lock (&self->priv->__lock_words);
#line 728 "engine.c"
			{
				GeeArrayList* _tmp4_;
#line 91 "../plugins/word-completion/engine.vala"
				_tmp4_ = self->priv->words;
#line 91 "../plugins/word-completion/engine.vala"
				gee_abstract_collection_add ((GeeAbstractCollection*) _tmp4_, word);
#line 735 "engine.c"
			}
			__finally4:
			{
				GeeArrayList* _tmp5_;
#line 90 "../plugins/word-completion/engine.vala"
				_tmp5_ = self->priv->words;
#line 90 "../plugins/word-completion/engine.vala"
				g_rec_mutex_unlock (&self->priv->__lock_words);
#line 744 "engine.c"
			}
#line 90 "../plugins/word-completion/engine.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 90 "../plugins/word-completion/engine.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 90 "../plugins/word-completion/engine.vala"
				g_clear_error (&_inner_error0_);
#line 90 "../plugins/word-completion/engine.vala"
				return;
#line 754 "engine.c"
			}
		}
	}
}


void
euclide_completion_parser_cancel_parsing (EuclideCompletionParser* self)
{
#line 96 "../plugins/word-completion/engine.vala"
	g_return_if_fail (self != NULL);
#line 97 "../plugins/word-completion/engine.vala"
	self->parsing_cancelled = TRUE;
#line 768 "engine.c"
}


static gboolean
euclide_completion_parser_parse_string (EuclideCompletionParser* self,
                                        const gchar* text)
{
	gboolean result = FALSE;
	gchar** word_array = NULL;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gint word_array_length1;
	gint _word_array_size_;
	gchar** _tmp2_;
	gint _tmp2__length1;
#line 100 "../plugins/word-completion/engine.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 100 "../plugins/word-completion/engine.vala"
	g_return_val_if_fail (text != NULL, FALSE);
#line 101 "../plugins/word-completion/engine.vala"
	self->parsing_cancelled = FALSE;
#line 102 "../plugins/word-completion/engine.vala"
	_tmp1_ = _tmp0_ = g_strsplit_set (text, EUCLIDE_COMPLETION_PARSER_delimiters, EUCLIDE_COMPLETION_PARSER_MAX_TOKENS);
#line 102 "../plugins/word-completion/engine.vala"
	word_array = _tmp1_;
#line 102 "../plugins/word-completion/engine.vala"
	word_array_length1 = _vala_array_length (_tmp0_);
#line 102 "../plugins/word-completion/engine.vala"
	_word_array_size_ = word_array_length1;
#line 103 "../plugins/word-completion/engine.vala"
	_tmp2_ = word_array;
#line 103 "../plugins/word-completion/engine.vala"
	_tmp2__length1 = word_array_length1;
#line 802 "engine.c"
	{
		gchar** current_word_collection = NULL;
		gint current_word_collection_length1 = 0;
		gint _current_word_collection_size_ = 0;
		gint current_word_it = 0;
#line 103 "../plugins/word-completion/engine.vala"
		current_word_collection = _tmp2_;
#line 103 "../plugins/word-completion/engine.vala"
		current_word_collection_length1 = _tmp2__length1;
#line 103 "../plugins/word-completion/engine.vala"
		for (current_word_it = 0; current_word_it < _tmp2__length1; current_word_it = current_word_it + 1) {
#line 814 "engine.c"
			gchar* _tmp3_;
			gchar* current_word = NULL;
#line 103 "../plugins/word-completion/engine.vala"
			_tmp3_ = g_strdup (current_word_collection[current_word_it]);
#line 103 "../plugins/word-completion/engine.vala"
			current_word = _tmp3_;
#line 821 "engine.c"
			{
				gboolean _tmp4_;
				const gchar* _tmp5_;
#line 104 "../plugins/word-completion/engine.vala"
				_tmp4_ = self->parsing_cancelled;
#line 104 "../plugins/word-completion/engine.vala"
				if (_tmp4_) {
#line 105 "../plugins/word-completion/engine.vala"
					g_debug ("engine.vala:105: Cancelling parse");
#line 106 "../plugins/word-completion/engine.vala"
					result = FALSE;
#line 106 "../plugins/word-completion/engine.vala"
					_g_free0 (current_word);
#line 106 "../plugins/word-completion/engine.vala"
					word_array = (_vala_array_free (word_array, word_array_length1, (GDestroyNotify) g_free), NULL);
#line 106 "../plugins/word-completion/engine.vala"
					return result;
#line 839 "engine.c"
				}
#line 108 "../plugins/word-completion/engine.vala"
				_tmp5_ = current_word;
#line 108 "../plugins/word-completion/engine.vala"
				euclide_completion_parser_add_word (self, _tmp5_);
#line 103 "../plugins/word-completion/engine.vala"
				_g_free0 (current_word);
#line 847 "engine.c"
			}
		}
	}
#line 110 "../plugins/word-completion/engine.vala"
	result = TRUE;
#line 110 "../plugins/word-completion/engine.vala"
	word_array = (_vala_array_free (word_array, word_array_length1, (GDestroyNotify) g_free), NULL);
#line 110 "../plugins/word-completion/engine.vala"
	return result;
#line 857 "engine.c"
}


static void
euclide_completion_parser_class_init (EuclideCompletionParserClass * klass)
{
#line 21 "../plugins/word-completion/engine.vala"
	euclide_completion_parser_parent_class = g_type_class_peek_parent (klass);
#line 21 "../plugins/word-completion/engine.vala"
	g_type_class_adjust_private_offset (klass, &EuclideCompletionParser_private_offset);
#line 21 "../plugins/word-completion/engine.vala"
	G_OBJECT_CLASS (klass)->finalize = euclide_completion_parser_finalize;
#line 870 "engine.c"
}


static void
euclide_completion_parser_instance_init (EuclideCompletionParser * self)
{
	gchar* _tmp0_;
#line 21 "../plugins/word-completion/engine.vala"
	self->priv = euclide_completion_parser_get_instance_private (self);
#line 31 "../plugins/word-completion/engine.vala"
	self->parsing_cancelled = FALSE;
#line 33 "../plugins/word-completion/engine.vala"
	g_rec_mutex_init (&self->priv->__lock_words);
#line 34 "../plugins/word-completion/engine.vala"
	_tmp0_ = g_strdup ("");
#line 34 "../plugins/word-completion/engine.vala"
	self->priv->last_word = _tmp0_;
#line 888 "engine.c"
}


static void
euclide_completion_parser_finalize (GObject * obj)
{
	EuclideCompletionParser * self;
#line 21 "../plugins/word-completion/engine.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, EUCLIDE_COMPLETION_TYPE_PARSER, EuclideCompletionParser);
#line 30 "../plugins/word-completion/engine.vala"
	_g_object_unref0 (self->text_view_words);
#line 33 "../plugins/word-completion/engine.vala"
	g_rec_mutex_clear (&self->priv->__lock_words);
#line 33 "../plugins/word-completion/engine.vala"
	_g_object_unref0 (self->priv->words);
#line 34 "../plugins/word-completion/engine.vala"
	_g_free0 (self->priv->last_word);
#line 21 "../plugins/word-completion/engine.vala"
	G_OBJECT_CLASS (euclide_completion_parser_parent_class)->finalize (obj);
#line 908 "engine.c"
}


GType
euclide_completion_parser_get_type (void)
{
	return euclide_completion_parser_type_id;
}


GType
euclide_completion_parser_register_type (GTypeModule * module)
{
	static const GTypeInfo g_define_type_info = { sizeof (EuclideCompletionParserClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) euclide_completion_parser_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (EuclideCompletionParser), 0, (GInstanceInitFunc) euclide_completion_parser_instance_init, NULL };
	euclide_completion_parser_type_id = g_type_module_register_type (module, G_TYPE_OBJECT, "EuclideCompletionParser", &g_define_type_info, 0);
	EuclideCompletionParser_private_offset = sizeof (EuclideCompletionParserPrivate);
	return euclide_completion_parser_type_id;
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



